class Event
{
    ///At the location of the event queue
    final int index;

    ///Event name
    final String event;

    ///Additional data
    final dynamic data;

    const Event(this.index, this.event, this.data);
}

typedef EventHandler = void Function(Event);

class Listener
{
    final Map<String, List<EventHandler>> _events = {};

    void addEvent(String event, EventHandler handler)
    {
        (_events[event] ??= []).add(handler);
    }

    void removeEvent(String event)
    {
        _events.remove(event);
    }

    void notice(String event, {dynamic data})
    {
        _events[event]?.forEach((handler) => handler(Event(1, event, data)));
    }

    bool hasEvent(String event)
    {
        return _events.containsKey(event);
    }
}